#Iterative algorithm for Sparse LDA

# common unstrained covariance

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Iterate <- function(X,X_tune,n,n_tune,p,KGlob,labelX,labelX_tune,
           WX,WX_tune,TauX,lambda,rho,mu.ini,Omega.ini,tol,
		   ite_max,BIC) {
	   
#----------------------------------------------------------------

nGlob <- n
pGlob <- p

#----------------------------------------------------------------

mu.old <- mu.ini
Omega.old <- Omega.ini

#----------------------------------------------------------------

rep <- 1
nplog <- 0

#----------------------------------------------------------------

while(rep <= ite_max) {

#----------------------------------------------------------------

#update Sigma/Omega
Omega.new <- Omega.update(X,mu.old,TauX,rho) 
                 
Omega.new <- 0.5*(Omega.new+t(Omega.new))

#----------------------------------------------------------------

#update mu
mu.new <- Mu.update(X,mu.old,TauX,Omega.new,lambda)

#----------------------------------------------------------------

#calculate likelihood
if(BIC==T) {
plog <- ploglik(X,mu.new,WX,Omega.new,labelX,KGlob,nGlob,pGlob,BIC)
}
if(BIC==F) {
plog <- ploglik(X_tune,mu.new,WX_tune,Omega.new,labelX_tune,
        KGlob,n_tune,pGlob,BIC)
}

#----------------------------------------------------------------

diff <- abs(plog-nplog)
#print(c(diff, rep))

if(diff < tol) {break}

#----------------------------------------------------------------

rep <- rep + 1  
nplog <- plog  
mu.old <- mu.new
Omega.old <- Omega.new

}

#----------------------------------------------------------------

list(mu_F=mu.new, Omega_F=Omega.new)

}
