#LDA-FP
#Iterative algorithm for sparse LDA

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#----------------------------------------------------------------

Iterate <- function(X,X_tune,n,n_tune,p,KGlob,labelX,labelX_tune,
          WX,WX_tune,TauX,lambda,mu.ini,sigma.ini,tol,
		  ite_max,tol_mu,ite_mu,BIC,mu.ave) {

#----------------------------------------------------------------

nGlob <- n
pGlob <- p

#----------------------------------------------------------------

mu.old <- mu.ini
sigma.old <- sigma.ini

#----------------------------------------------------------------

rep <- 1
nplog <- 0

#----------------------------------------------------------------

while(rep <= ite_max) {

#----------------------------------------------------------------

#update sigma
sigma.new <- sigma.update(X,mu.old,labelX) 
                 
#----------------------------------------------------------------

#update mu
mu.new <- MuSM.update(X,mu.old,TauX,WX,sigma.new,
           mu.ave,lambda,tol_mu,ite_mu) 

#----------------------------------------------------------------

#calculate likelihood
if(BIC==T) {
plog <- ploglik(X,mu.new,WX,sigma.new,labelX,KGlob,nGlob,pGlob,BIC)
}
if(BIC==F) {
plog <- ploglik(X_tune,mu.new,WX_tune,sigma.new,labelX_tune,
          KGlob,n_tune,pGlob,BIC)
}

#----------------------------------------------------------------

diff <- abs(plog-nplog)
#print(c(diff, rep))

if(diff < tol) {break}

#----------------------------------------------------------------

rep <- rep + 1  
nplog <- plog  
mu.old <- mu.new
sigma.old <- sigma.new

}

#----------------------------------------------------------------

list(mu_F=mu.new, sigma_F=sigma.new)

}
