#LDA-FP

#general function for classification

#----------------------------------------------------------------

LDA <- function(X,X_tune,n,n_tune,p,labelX,labelX_tune,
        BIC,num_cluster,lambda,tol,ite_max,tol_mu,ite_mu){
  
#----------------------------------------------------------------

#centralize
mu_X <- apply(X,2,mean)
X <- t(t(X)-mu_X)
mu_Xtune <- apply(X_tune,2,mean)
X_tune <- t(t(X_tune)-mu_Xtune)

#----------------------------------------------------------------

nGlob <- n 
pGlob <- p
KGlob <- num_cluster

#----------------------------------------------------------------

# possible values of penalization parameters
lam1_num <- length(lambda)
 
#----------------------------------------------------------------

#record (-1)*predicitve log-likelihood or BIC value
pred_likelihood <- rep(-1e5, lam1_num)
#record mean of X based on classification
classify.mu <- matrix(0, lam1_num, KGlob*pGlob)
#record precision matrix of X based on classification
classify.sigma <- matrix(0, lam1_num, pGlob)

#----------------------------------------------------------------

#matrix TauX representing label based on X
TauX <- matrix(0, nGlob, KGlob)
for(i in 1:n) {
TauX[i,labelX[i]] <- 1
}
#vector WX representing proportion
WX <- rep(0,KGlob)
for(k in 1:KGlob) {
WX[k] <- sum(labelX==k) / nGlob
}
#vector WX_tune representing proportion
WX_tune <- rep(0,KGlob)
for(k in 1:KGlob) {
WX_tune[k] <- sum(labelX_tune==k) / (dim(X_tune)[1])
}

#----------------------------------------------------------------

#initial values
ini.out <- ini(X,KGlob,labelX)
mu.ini <- ini.out$mu
sigma.ini <- ini.out$sigma

for(lam1 in 1:lam1_num) {
lambda_c <- lambda[lam1]
#-------------------------------------------------------------    
#iterative algorithm
out <- Iterate(X,X_tune,n,n_tune,p,KGlob,labelX,labelX_tune,
          WX,WX_tune,TauX,lambda_c,mu.ini,sigma.ini,tol,
		  ite_max,tol_mu,ite_mu,BIC,mu.ini)
mu_F <- out$mu_F
sigma_F <- out$sigma_F
#-------------------------------------------------------------   
classify.mu[lam1,] <- vec(mu_F)
classify.sigma[lam1,] <- sigma_F
#calculate the likelihood based on the tuning data
if(BIC==T) { 
 plog <- ploglik(X,mu_F,WX,sigma_F,labelX,KGlob,nGlob,pGlob,BIC)
}
if(BIC==F) {
 plog <- ploglik(X_tune,mu_F,WX_tune,sigma_F,labelX_tune,
          KGlob,n_tune,pGlob,BIC)
}
pred_likelihood[lam1] <- plog
#print(c(plog, lam1))
}

#----------------------------------------------------------------

target <- pred_likelihood[1]
target_m <- 1
for(lam1 in 1:lam1_num) {
 if(target > pred_likelihood[lam1]) {
  target <- pred_likelihood[lam1]
  target_m <- lam1
 }
}

#----------------------------------------------------------------

lambda_F <- lambda[target_m]
vec_mean <- classify.mu[target_m,]
group_mean <- invvec(vec_mean,pGlob)
group_var <- classify.sigma[target_m,]

#----------------------------------------------------------------

group_member <- rep(NA,nGlob)
for(i in 1:nGlob) {
postpro <- rep(NA, KGlob)
for(k in 1:KGlob) {
 postpro[k] <- WX[k]*mvnf(X[i,], group_mean[k,], group_var)
}
group_member[i] <- which.max(postpro/sum(postpro))
}

#----------------------------------------------------------------

output <- list(lambda=lambda_F,
           group_member=group_member,mean=group_mean,var=group_var)
		   # pred_likelihood=pred_likelihood,
		   # classify.mu=classify.mu,
		   # classify.sigma=classify.sigma)
		   
return(output)

}

