#Penalized LDA
#Witten and Tibshirani (2011) JRSSB

#Use CV to select tuning parameters
#Two kinds of penalties: LASSO, Fused LASSO

library(penalizedLDA)

#----------------------------------------------------------------

PLDA <- function(X, Y, Xtest, lambda) {

#----------------------------------------------------------------

lasso <- PenalizedLDA.cv(x=X, y=Y, lambdas=lambda)
out_L <- PenalizedLDA(x=X, y=Y, xte=Xtest, lambda=lasso$bestlambda, 
                      K=lasso$bestK)
label_Ltest <- out_L$ypred[,out_L$K]
index_L <- which(out_L$discrim[,1]!=0)
if(lasso$bestK>1) {
for(i in 2:lasso$bestK) {
index_L <- union(index_L, which(out_L$discrim[,i]!=0))
}
}
label_Ltrain <- PenalizedLDA(X, Y, xte=X, lambda=lasso$bestlambda, 
                K=lasso$bestK)$ypred[,lasso$bestK]
result_L <- list(varIndex=index_L, label_train=label_Ltrain, 
                 label_test=label_Ltest)

#----------------------------------------------------------------

fusedL <- PenalizedLDA.cv(x=X, y=Y, type="ordered", lambdas=lambda, lambda2=.3)
out_FL <- PenalizedLDA(x=X, y=Y, xte=Xtest, type="ordered", 
                       lambda=fusedL$bestlambda, K=fusedL$bestK, lambda2=.3)
label_FLtest <- out_FL$ypred[,out_FL$K]
index_FL <- which(out_FL$discrim[,1]!=0)
if(fusedL$bestK>1) {
for(i in 2:fusedL$bestK) {
index_FL <- union(index_FL, which(out_FL$discrim[,i]!=0))
}
}
label_FLtrain <- PenalizedLDA(X, Y, xte=X, lambda=fusedL$bestlambda, 
                K=fusedL$bestK,lambda2=.3)$ypred[,fusedL$bestK]
result_FL <- list(varIndex=index_FL, label_train=label_FLtrain, 
                  label_test=label_FLtest)
	
#----------------------------------------------------------------

return(list(lasso=result_L, fusedl=result_FL))

}

